import { Maximum } from './maximum.class';
import { Minimum } from './minimum.class';
export declare class Range<Min extends number, Max extends number> {
    #private;
    get [Symbol.toStringTag](): string;
    readonly max: Max;
    readonly min: Min;
    static create<Min extends number, Max extends number>(min: Min, max: Max): Range<Min, Max>;
    static createMaximum<Value extends number>(value: Value): Maximum<Value>;
    static createMinimum<Value extends number>(value: Value): Minimum<Value>;
    static isRange<Min extends number, Max extends number>(value: any, min?: Min, max?: Max): value is Range<Min, Max>;
    constructor(min: Min, max: Max);
    has(value: number): boolean;
    hasEvery(...values: number[]): boolean;
    hasSome(...values: number[]): boolean;
    isBetween(min: number, max: number): boolean;
    isBetweenEvery(...ranges: [number, number][]): boolean;
    isBetweenSome(...ranges: [number, number][]): boolean;
    getMax(): Max;
    getMin(): Min;
    maxGreaterThan(value: number): boolean;
    maxLessThan(value: number): boolean;
    minGreaterThan(value: number): boolean;
    minLessThan(value: number): boolean;
    toArray(): readonly [Min, Max];
    valueOf(): Readonly<{
        min: Min;
        max: Max;
    }>;
}
